// GraphTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "GraphTest.h"
#include "GraphTestDlg.h"
#include ".\graphtestdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGraphTestDlg dialog

CGraphTestDlg::CGraphTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGraphTestDlg::IDD, pParent)
	, m_iYScale(0)
	, m_DispFrom(0)
	, m_DispTo(0)
{
	//{{AFX_DATA_INIT(CGraphTestDlg)
	m_Scale = 0;
	m_Simulate = FALSE;
	m_iYScale = 1;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGraphTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGraphTestDlg)
	DDX_Control(pDX, IDC_GRAPH, m_Graph);
	DDX_CBIndex(pDX, IDC_SCALE_COMBO, m_Scale);
	DDX_Check(pDX, IDC_CHECK_SIMU, m_Simulate);
	//}}AFX_DATA_MAP
	DDX_Text(pDX, IDC_SCALE, m_iYScale);
	DDX_Text(pDX, IDC_FROM, m_DispFrom);
	DDV_MinMaxUInt(pDX, m_DispFrom, 0, 100000);
	DDX_Text(pDX, IDC_TO, m_DispTo);
	DDV_MinMaxUInt(pDX, m_DispTo, 1, 100000);
	DDV_MinMaxInt(pDX, m_iYScale, 1, 10000);
	DDX_Control(pDX, IDC_STAT_BG, m_BGStat);
	DDX_Control(pDX, IDC_STAT_AXS, m_AxsStat);
	DDX_Control(pDX, IDC_STAT_TXT, m_TxtStat);
	DDX_Control(pDX, IDC_STAT_BAR, m_BarStat);
	DDX_Control(pDX, IDC_COMBO_BAR, m_BarCombo);
}

BEGIN_MESSAGE_MAP(CGraphTestDlg, CDialog)
	//{{AFX_MSG_MAP(CGraphTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_CBN_SELCHANGE(IDC_SCALE_COMBO, OnSelchangeScaleCombo)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CHECK_SIMU, OnCheckSimu)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_SET_SCALE, OnBnClickedSetScale)
	ON_BN_CLICKED(IDC_MOVE_UP, OnBnClickedMoveUp)
	ON_BN_CLICKED(IDC_MOVE_DOWN, OnBnClickedMoveDown)
	ON_BN_CLICKED(IDC_TXTCOLOR3, OnBnClickedTxtcolor3)
	ON_BN_CLICKED(IDC_AXCOLOR2, OnBnClickedAxcolor2)
	ON_BN_CLICKED(IDC_BGCOLOR, OnBnClickedBgcolor)
	ON_CBN_SELCHANGE(IDC_COMBO_BAR, OnCbnSelchangeComboBar)
	ON_BN_CLICKED(IDC_BARCOLOR, OnBnClickedBarcolor)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGraphTestDlg message handlers

BOOL CGraphTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	m_Graph.SetUnit("centi-meters");
	m_Graph.SetScale(10);
	m_Graph.GetDisplayRange(m_DispFrom, m_DispTo);
	m_iYScale = 10;

	for(UINT i=0;i<10;i++)
	{
		char tmp[16];
		sprintf(tmp, "bar%d", i);
		m_Graph.AddBar(rand()%m_DispTo, RGB(rand()%256, rand()%256, rand()%256), tmp);

		sprintf(tmp, "%d", i);
		m_BarCombo.AddString(tmp);
	}
	m_Graph.SetBGColor(RGB(0,0,0));
	m_Graph.SetAxisColor(RGB(255,255,255));
	m_Graph.SetTextColor(RGB(0,0,255));

	m_TxtStat.stColor = m_Graph.GetTextColor();
	m_AxsStat.stColor = m_Graph.GetAxisColor();
	m_BGStat.stColor = m_Graph.GetBGColor();
	m_TxtStat.Invalidate();
	m_AxsStat.Invalidate();
	m_BGStat.Invalidate();

	m_BarCombo.SetCurSel(0);
	OnCbnSelchangeComboBar();

	UpdateData(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CGraphTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGraphTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CGraphTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CGraphTestDlg::OnSelchangeScaleCombo() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_Scale == 0)
		m_Graph.SetUnit("centi-meters");
	else
		m_Graph.SetUnit("inches");
}

void CGraphTestDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	for(UINT i=0;i<m_Graph.GetNumberOfBars();i++)
	{
		m_Graph.SetBarValue(i,rand()%m_DispTo, (i==m_Graph.GetNumberOfBars()-1));
	}

	CDialog::OnTimer(nIDEvent);
}

void CGraphTestDlg::OnCheckSimu() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_Simulate)
		SetTimer(1,250,NULL);
	else
		KillTimer(1);
}

void CGraphTestDlg::OnBnClickedSetScale()
{
	UpdateData(TRUE);
	m_Graph.SetScale(m_iYScale);
	m_Graph.SetDisplayRange(m_DispFrom, m_DispTo);
}

void CGraphTestDlg::OnBnClickedMoveUp()
{
	// TODO: Add your control notification handler code here
	int start=0, end=0;
	m_Graph.GetDisplayRange(start, end);

	m_Graph.SetDisplayRange(start+m_Graph.GetScale(), end+m_Graph.GetScale());
	m_Graph.GetDisplayRange(m_DispFrom, m_DispTo);

	UpdateData(FALSE);
}

void CGraphTestDlg::OnBnClickedMoveDown()
{
	// TODO: Add your control notification handler code here
	int start=0, end=0;
	m_Graph.GetDisplayRange(start, end);

	m_Graph.SetDisplayRange(start-m_Graph.GetScale(), end-m_Graph.GetScale());
	m_Graph.GetDisplayRange(m_DispFrom, m_DispTo);

	UpdateData(FALSE);
}

void CGraphTestDlg::OnBnClickedTxtcolor3()
{
	CColorDialog pDlg(m_Graph.GetTextColor());
	if(pDlg.DoModal() == IDOK)
	{
		m_TxtStat.stColor = pDlg.GetColor();
		m_Graph.SetTextColor(m_TxtStat.stColor);
		m_TxtStat.Invalidate();
	}
}

void CGraphTestDlg::OnBnClickedAxcolor2()
{
	CColorDialog pDlg(m_Graph.GetAxisColor());
	if(pDlg.DoModal() == IDOK)
	{
		m_AxsStat.stColor = pDlg.GetColor();
		m_Graph.SetAxisColor(m_AxsStat.stColor);
		m_AxsStat.Invalidate();
	}
}

void CGraphTestDlg::OnBnClickedBgcolor()
{
	CColorDialog pDlg(m_Graph.GetBGColor());
	if(pDlg.DoModal() == IDOK)
	{
		m_BGStat.stColor = pDlg.GetColor();
		m_Graph.SetBGColor(m_BGStat.stColor);
		m_BGStat.Invalidate();
	}
}

void CGraphTestDlg::OnCbnSelchangeComboBar()
{
	CString str;
	m_BarCombo.GetLBText(m_BarCombo.GetCurSel(), str);
	int barID = atoi(str);
	if(barID>=0)
	{
		m_BarStat.stColor = m_Graph.GetBarColor(barID);
		m_BarStat.Invalidate();
	}
}

void CGraphTestDlg::OnBnClickedBarcolor()
{
	CString str;
	m_BarCombo.GetLBText(m_BarCombo.GetCurSel(), str);
	int barID = atoi(str);
	if(barID>=0)
	{
		CColorDialog pDlg(m_Graph.GetBarColor(barID));
		if(pDlg.DoModal() == IDOK)
		{
			m_BarStat.stColor = pDlg.GetColor();
			m_Graph.SetBarColor(barID, m_BarStat.stColor);
			m_BarStat.Invalidate();
		}
	}
}
